function test_diff = func_Test(theta,M,mean_WY,mean_WH,var_WY,var_WH,cov_WY_WH,e_WY,e_WM,n,e_one,alpha,beta)
    
    sign_theta = (theta>=0)-(theta<0);
    abs_theta  = abs(theta);
               
    ghat  = [-mean_WY*sign_theta,mean_WY*sign_theta-abs_theta];
    sigma = sqrt([var_WY,var_WY]);
    
    if size(M,2) > 0            
        ghat  = [ghat,-mean_WY*sign_theta-mean_WH*abs_theta];
        sigma = [sigma,sqrt(var_WY+var_WH*(theta^2)+2*theta*cov_WY_WH)];
    end
           
    pre_select = sigma >= 1e-3;
            
    if max(ghat(~pre_select))>0
        test_diff = 10; 
    else
        
        ghat  = ghat(pre_select);
        sigma = sigma(pre_select);       
        
        tstat = max(sqrt(n)*ghat./sigma);
        
        select = (sqrt(n)*ghat./sigma) > -2*quantile(func_Bootmax(pre_select,n,M,e_WY,e_WM,sign_theta,abs_theta,e_one,ghat,sigma),1-beta);                
        cv = quantile(func_Bootmax(pre_select&select,n,M,e_WY,e_WM,sign_theta,abs_theta,e_one,ghat,sigma),1-alpha+2*beta);
        
        test_diff = tstat - cv;
    end    
end