function [Y,T,Ts,R,Z] = func_DGP(n,U,design)
    
    Z   = (1:n)'>n/2;           
    
    rho = design(1); 
           
    U1 = normcdf((norminv(U(:,1))+rho*norminv(U(:,2))+rho*norminv(U(:,3))+rho*norminv(U(:,4)))/sqrt(1+rho^2+rho^2+rho^2));
    U2 = normcdf((norminv(U(:,2))+rho*norminv(U(:,3))+rho*norminv(U(:,4))+rho*norminv(U(:,1)))/sqrt(1+rho^2+rho^2+rho^2));
    U3 = normcdf((norminv(U(:,3))+rho*norminv(U(:,4))+rho*norminv(U(:,1))+rho*norminv(U(:,2)))/sqrt(1+rho^2+rho^2+rho^2));    
    U4 = normcdf((norminv(U(:,4))+rho*norminv(U(:,1))+rho*norminv(U(:,2))+rho*norminv(U(:,3)))/sqrt(1+rho^2+rho^2+rho^2));    
    
    Ts = -3/4+1/2*Z+U1>= 0;
    Y  = norminv(U2)+2*Ts;        
    T  = logical(Ts+(U3<=design(2)).*(1-2*Ts));
    R  = logical(Ts+(U4<=design(2)).*(1-2*Ts));

end