clear 
clc 

N_para      = 2000; 
random_list = 100910+(1:N_para); 
rng(random_list(1)-1,'v4'); 

n = 500;
design_list = [.25,0;.25,.2;.25,.4;];
K_list  = 1:4;
N_boot  = 1000;  
beta  = .001;
alpha = .05;

theta_list = 0:.1:6;

eps = 0.01;

epsilon_boot = norminv(rand(n,N_boot));

mkdir('temp');  
mkdir('results');  
save('temp/MC_List_Setting.mat') 



for numero = 1:N_para
    load('temp/MC_List_Setting.mat') 
    rng(random_list(numero),'v4'); 

    for design_type = 1:size(design_list,1)

        [Y,T,Ts,R,Z] = func_DGP(n,rand(n,4),design_list(design_type,:));       
        W = (Z-.5)/(.5*(1-.5));                   

        CI_theta = NaN(2,size(K_list,2),3);
        for K_index = 1:size(K_list,2)
            K_n = K_list(K_index);          

            Y_d = sum(repmat(Y,[1,K_n])<=repmat(quantile(Y,(1:K_n)/K_n),[n,1]),2);

            for method_index = 1:3         
                if method_index == 1
                    M = repmat(Y_d,[1,K_n])==repmat(1:K_n,[n,1]); 
                elseif method_index == 2
                    M = repmat(K_n*T+Y_d,[1,2*K_n])==repmat(1:2*K_n,[n,1]);
                else
                    M = repmat(2*K_n*R+K_n*T+Y_d,[1,4*K_n])==repmat(1:4*K_n,[n,1]);                
                end

                if sum(std(M)>eps) <= 1
                    M = ones(n,1);
                    PlusSet = 1;    
                else
                    M = M(:,std(M)>eps);
                    PlusSet = transpose(double(dec2bin(0:(2^size(M,2)-1),size(M,2)))==48);    
                end

                p = size(PlusSet,2)+2;

                temp = NaN(size(theta_list));
                for theta_index = 1:size(theta_list,2)
                    theta = theta_list(theta_index);
                    Mom = [-W.*Y*((theta>=0)-(theta<0)),W.*Y*((theta>=0)-(theta<0))-abs(theta),-repmat(W,[1,p-2]).*(repmat(Y,[1,p-2])*((theta>=0)-(theta<0))+(M*double(PlusSet)-.5)*abs(theta))];
                    boot_moment = epsilon_boot'*(sqrt(n)*(Mom-repmat(mean(Mom,1),[n,1]))./repmat(std(Mom,0,1),[n,1]))/n;
                    select = sqrt(n)*mean(Mom,1)./std(Mom,0,1)>-2*quantile(max(boot_moment,[],2),1-beta);        
                    if sum(select)==0
                        temp(theta_index) = max(sqrt(n)*mean(Mom,1)./std(Mom,0,1)) <= 0 ;
                    else
                        temp(theta_index) = max(sqrt(n)*mean(Mom,1)./std(Mom,0,1)) <= quantile(max(boot_moment(:,select),[],2),1-alpha+2*beta);   
                    end                
                end      
                CI_theta(:,K_index,method_index) = quantile(theta_list(temp==1),[0,1]);
            end                             
        end

        save(strcat('temp/result_',num2str(design_type),'_',num2str(numero),'.mat'),'CI_theta');      
    end   
end


load('temp/MC_List_Setting.mat') 

for design_type = 1:size(design_list,1)        

    CI_theta_list = [];
    pending = [];
    for numero = 1:2000;
        try
            eval(['load temp/result_',num2str(design_type),'_',num2str(numero),'.mat;'])

            CI_theta_list = cat(4,CI_theta_list,CI_theta);

        catch
            pending = [pending;numero];
        end
    end
    eval(['save resultados',num2str(design_type),' CI_theta_list pending;'])
end


load('temp/MC_List_Setting.mat'); 

for design_type = 1:size(design_list,1)        
        
    n0 = 1e6; 
    [Y,T,Ts,R,Z] = func_DGP(n0,rand(n0,4),design_list(design_type,:));
    W =  (Z-.5)/(.5*(1-.5));

    ITT = Y'*W/n0;
    LATE = ITT/(Ts'*W/n0);     
    Wald = ITT/(T'*W/n0);        
    
    K = 100;

    H = dummyvar(sum(repmat(Y,[1,K])<=repmat(quantile(Y,(1/K):(1/K):1),[n0,1]),2));
    TV1 = sum(abs(mean(H(Z==1,:))-mean(H(Z==0,:))))/2;                
    
    H = dummyvar(K*T+sum(repmat(Y,[1,K])<=repmat(quantile(Y,(1/K):(1/K):1),[n0,1]),2));
    TV2 = sum(abs(mean(H(Z==1,:))-mean(H(Z==0,:))))/2;                

    H = dummyvar(2*K*R+K*T+sum(repmat(Y,[1,K])<=repmat(quantile(Y,(1/K):(1/K):1),[n0,1]),2));
    TV3 = sum(abs(mean(H(Z==1,:))-mean(H(Z==0,:))))/2;                
    
    [LATE;ITT;Wald;ITT/TV1;ITT/TV2;ITT/TV3]       
             
    load(strcat('resultados',num2str(design_type),'.mat'));      
        
    for method_index = 1:3 
        eval(['UB = ITT/TV',num2str(method_index),';'])            
        
        Cov1 = mean(repmat(theta_list,[1,1,1,size(CI_theta_list,4)])>=repmat(CI_theta_list(1,1,method_index,:),[1,size(theta_list,2),1]) & repmat(theta_list,[1,1,1,size(CI_theta_list,4)])<=repmat(CI_theta_list(2,1,method_index,:),[1,size(theta_list,2),1,1]),4);
        Cov2 = mean(repmat(theta_list,[1,1,1,size(CI_theta_list,4)])>=repmat(CI_theta_list(1,2,method_index,:),[1,size(theta_list,2),1]) & repmat(theta_list,[1,1,1,size(CI_theta_list,4)])<=repmat(CI_theta_list(2,2,method_index,:),[1,size(theta_list,2),1,1]),4);
        Cov3 = mean(repmat(theta_list,[1,1,1,size(CI_theta_list,4)])>=repmat(CI_theta_list(1,3,method_index,:),[1,size(theta_list,2),1]) & repmat(theta_list,[1,1,1,size(CI_theta_list,4)])<=repmat(CI_theta_list(2,3,method_index,:),[1,size(theta_list,2),1,1]),4);
        Cov4 = mean(repmat(theta_list,[1,1,1,size(CI_theta_list,4)])>=repmat(CI_theta_list(1,4,method_index,:),[1,size(theta_list,2),1]) & repmat(theta_list,[1,1,1,size(CI_theta_list,4)])<=repmat(CI_theta_list(2,4,method_index,:),[1,size(theta_list,2),1,1]),4);

        f=figure();
        set(0,'defaultTextInterpreter','latex'); 
        plot(theta_list,Cov1,'-k');
        hold on 
        plot(theta_list,Cov2,'-r');
        hold on 
        plot(theta_list,Cov3,'-b');
        hold on 
        plot(theta_list,Cov4,'-g');
        hold on 
        line([ITT ITT UB UB], [0 1 1 0],'LineStyle',':','LineWidth',1)
        hold on; 
        plot(theta_list,(1-alpha)*ones(size(theta_list)),':r','LineWidth',1);
        axis([0 6 0 1])
        ax = gca;
        ax.YTick = [0 .9 1];
        ax.YTickLabel = {'0','.9',''};
        set(gca,'FontSize',18)
        legend({'K_n=1','K_n=2','K_n=3','K_n=4','Identified Set'},'Location','southeastoutside','FontSize',18);%
        legend boxoff
        box off
        xlabel('LATE','FontSize',18);
        ylabel('Coverage','FontSize',18);
        print(f,'-dpng','-r200',strcat('results/fig',num2str(design_type),'_',num2str(method_index),'.png'))
        close   

    end    
   
% 
end